# Copyright 2008, Chris Glasier

require 'sketchup.rb'

module Glasier_jstTransformations

def Glasier_jstTransformations.setup
      
@dlg = UI::WebDialog.new("JST Transformations", false, "JST", 300, 205, 0, 0, true)
      
@dlg.set_size 325,205
      
subDir = "C:/Program Files/Google/Google SketchUp 7/Plugins/"
fileName = "jstTransformations.htm"
	
@dlg.set_file File.join(File.dirname(__FILE__), subDir+fileName)

@dlg.add_action_callback("clearAll") {|d, p|
      
ents=Sketchup.active_model.active_entities
status = ents.clear!  }

#makes an array of an existing model's entities and their parameters 
      

@dlg.add_action_callback("reportAnalysis") {|d, p|
      
a = 0

model = Sketchup.active_model
model.options["UnitsOptions"]["SuppressUnitsDisplay"]= true
entities = model.active_entities
entity = entities[0]

t = entity.transformation
to = t.origin

array = []
array[0] =[to[0],to[1],to[2], "xyz"]
array[0] = array[0].join(",")
array[1] =[(t.xaxis.angle_between X_AXIS).radians,(t.yaxis.angle_between Y_AXIS).radians,(t.zaxis.angle_between Z_AXIS).radians,"angle_between"]
array[1] = array[1].join(",")
array = array.join(";")

cmd = "receiveReport('#{array}');"
@dlg.execute_script (cmd)   }

#makes geometry for regular objects like beams, columns and slabs
	  
@dlg.add_action_callback("drawer") {|d, p|

model = Sketchup.active_model
entities = model.entities
group = entities.add_group
entities = group.entities

a= p.split(",")
		
theX = Integer(a[0]).mm
theY = Integer(a[1]).mm
theZ = Integer(a[2]).mm
	
point = Geom::Point3d.new theX, theY, theZ
t = Geom::Transformation.new point
		
#for faces
theW	= Integer(a[3]).mm
theD =  Integer(a[4]).mm
theH = Integer(a[5]).mm
	
pts = []
pts[0] = [0, 0, 0]
pts[1] = [theW, 0, 0]
pts[2] = [theW, theD, 0]
pts[3] = [0, theD, 0]
	
base = entities.add_face pts
	
height = -theH
	
base.pushpull height

group = group.move! t}
	

@dlg.add_action_callback("turn") {|d, p|
a= p.split(",")
	
entNo = Integer(a[0])
	
model = Sketchup.active_model
entities = model.active_entities
ent = entities[entNo]
	
theDegrees = Integer(a[1]).degrees
theAxis = a[2]
	
rv = Geom::Vector3d.new(0,0,1) if theAxis == "z"
rv = Geom::Vector3d.new(0,1,0) if theAxis == "y"
rv = Geom::Vector3d.new(1,0,0) if theAxis == "x"
	
tr = Geom::Transformation.rotation(Geom::Point3d.new(ent.bounds.center), rv, theDegrees)
	
ent.transform! tr   }


@dlg.add_action_callback("mover") {|d, p|
	
a = p.split(",")
	
entityNo =  Integer(a[0])
theX = Integer(a[1]).mm
theY = Integer(a[2]).mm
theZ = Integer(a[3]).mm
			
model = Sketchup.active_model
entities = model.active_entities
entity = entities[entityNo]
		
point = Geom::Point3d.new theX, theY, theZ
t = Geom::Transformation.new point
	
entity.transform! t    }


@dlg.add_action_callback("compAxesOn") {|d, p|
	
Sketchup.active_model.rendering_options["DisplayInstanceAxes"]=true	}
	
		            
@dlg.show()

end

end	  

if (not file_loaded?("jstTransformations.rb"))
    
UI.menu("Plugins").add_item("JST Transformations") { Glasier_jstTransformations.setup }
	
end
	
file_loaded("jstTransformations.rb")   



      


      
    